/*  Program to convert lat lon coords to x y coords  */

#include <stdio.h>
#include <math.h>

main(argc,argv)
int   argc;
char  *argv[];
{
   char  ibuff[80];
   int   i=0,j;
   float latorig,lonorig,lat[10000],lon[10000],x,y,d2r;
   float factor;

   d2r = acos(-1.0)/180.0;
   if (argc == 1)
     fprintf(stderr,"Input longitude and latitude of origin:  ");
   fgets(ibuff,80,stdin);
   sscanf(ibuff,"%f %f",&lonorig,&latorig);
   factor = d2r*cos(d2r*latorig)*
	    (6378.139*(1.0-sin(d2r*latorig)*sin(d2r*latorig)/298.247));
   if (argc == 1)
     fprintf(stderr,"Input lon and lat or CTL-D to exit:\n");
   while (fgets(ibuff,80,stdin) != NULL)
      {
      sscanf(ibuff,"%f %f",&lon[i],&lat[i]);
      ++i;
      }
   fprintf(stdout,"   lon       lat         x           y\n");
   for (j=0; j < i; ++j)
      {
      x = (lon[j] - lonorig)*factor;
      y = (lat[j] - latorig)*111.32;
      fprintf(stdout,"%f  %f ->  %f  %f\n",lon[j],lat[j],x,y);
      }
   fprintf(stdout,"%f\n",d2r);
   fprintf(stdout,"%f\n",latorig);
   fprintf(stdout,"%f\n",sin(d2r*latorig));
   fprintf(stdout,"%f\n",cos(d2r*latorig));
   fprintf(stdout,"%f\n",factor);
}
